import { styled } from '@nuskin/foundation-theme';
import { NsTypography } from '../../typography';

type AutoCompleteButtonProps = {
    text: string;
    show: boolean;
    onClick(): void;
    testId?: string;
    recentSearchText: string;
};
export const StyledClear = styled(NsTypography)`
    :hover {
        opacity: 0.5;
    }
`;
export const RecentClearAll = (props: AutoCompleteButtonProps) => {
    const { show, onClick, text, testId, recentSearchText } = props;
    if (!show) {
        return null;
    }
    return (
        <li className="justify-between flex p-3" onClick={onClick}>
            <NsTypography data-testid={testId} variant="body-m" weight="bold">
                {recentSearchText}
            </NsTypography>
            <StyledClear
                data-testid={testId}
                variant="body-m"
                weight="bold"
                className="cursor-pointer hover:opacity-40"
            >
                {text}
            </StyledClear>
        </li>
    );
};
