import { styled, ColorUtils } from '@nuskin/foundation-theme';
import { NsTypographyProps } from './types.d';

const { paletteColor } = ColorUtils;

const variantStyles = {
    h1: 'font-size: 36px; line-height: 44px;',
    h2: 'font-size: 26px; line-height: 32px',
    h3: 'font-size: 22px; line-height: 28px',
    h4: 'font-size: 18px; line-height: 26px',
    h5: 'font-size: 16px; line-height: 22px',
    h6: 'font-size: 14px; line-height: 20px',
    'title-l': 'font-size: 22px; line-height: 28px; font-weight:bold',
    'title-m': 'font-size: 16px; line-height: 20px; font-weight:bold',
    'title-s': 'font-size: 16px; line-height: 16px; font-weight:bold',
    'label-l': 'font-size: 20px; line-height: 26px; font-weight:600',
    'label-m': 'font-size: 16px; line-height: 22px; font-weight:600',
    'label-s': 'font-size: 14px; line-height: 20px; font-weight:700',
    'body-xl': 'font-size: 18px; line-height: 22px',
    'body-l': 'font-size: 16px; line-height: 22px',
    'body-m': 'font-size: 14px; line-height: 20px',
    'body-s': 'font-size: 12px; line-height: 16px',
    'body-xs': 'font-size: 10px; line-height: 15px',
    CTA: 'font-size: 11px; line-height: 16px',
};

const fontWeightMap = {
    light: 300,
    normal: 400,
    bold: 600,
};

export const StyledTypography = styled.div<NsTypographyProps>`
    font-family: Inter;
    color: ${({ color, colorOverride }) => (colorOverride?.startsWith('#') ? colorOverride : paletteColor(color))};
    font-weight: ${({ weight = 'normal' }) => fontWeightMap[weight]};
    font-style: ${({ fontStyle }) => fontStyle};
    ${({ variant = 'h1' }) => variantStyles[variant]};
    text-decoration-line: ${({ decoration }) => decoration};
`;
